commit 7db6cf9f9dc54a3edebcd6bfc5362108519b1cbb
Author: Priya <pdeo@Phlegethon.(none)>
Date:   Sun Apr 28 13:47:14 2013 -0400

    Changed all TODO and @TODO to @todo to conform to doxygen.

diff --git a/scout/libscout/launch/helper_nodes.launch b/scout/libscout/launch/helper_nodes.launch
index 6825782..eca4e08 100644
--- a/scout/libscout/launch/helper_nodes.launch
+++ b/scout/libscout/launch/helper_nodes.launch
@@ -1,5 +1,5 @@
 <launch>
   <node name="motors" pkg="motors" type="motors_node" />
   <node name="encoders" pkg="encoders" type="encoders_node" />
-  <!-- TODO add more -->
+  <!-- @todo add more -->
 </launch>
diff --git a/scout/libscout/launch/rosscout.launch b/scout/libscout/launch/rosscout.launch
index 83846d2..c9817eb 100644
--- a/scout/libscout/launch/rosscout.launch
+++ b/scout/libscout/launch/rosscout.launch
@@ -7,5 +7,5 @@
 <launch>
   <include file="$(find scout_avr)/launch/rosserial.launch" />
   <include file="$(find libscout)/launch/helper_nodes.launch" />
-  <!-- TODO launch a top-level libscout behavior -->
+  <!-- @todo launch a top-level libscout behavior -->
 </launch>
diff --git a/scout/libscout/src/MotorControl.cpp b/scout/libscout/src/MotorControl.cpp
index 352aa0b..555d129 100644
--- a/scout/libscout/src/MotorControl.cpp
+++ b/scout/libscout/src/MotorControl.cpp
@@ -215,7 +215,7 @@ int MotorControl::trim_speed(string which_str, int speed)
  * Sends a request to the query_motors service which will reply with the
  *  current speed of each motor.
  *
- * @TODO Change so we can get multiple motor speeds with one call
+ * @todo Change so we can get multiple motor speeds with one call
  *
  * @param which A bitmask that will specify which motor speed should be
  *  returned
diff --git a/scout/libscout/src/SonarControl.cpp b/scout/libscout/src/SonarControl.cpp
index e71731f..1913197 100644
--- a/scout/libscout/src/SonarControl.cpp
+++ b/scout/libscout/src/SonarControl.cpp
@@ -208,7 +208,7 @@ int* SonarControl::get_sonar_readings()
  **/
 //float sonar_to_dist(float sonar_value)
 //{
-    //TODO impelement later based on sonar readings
+    //@todo impelement later based on sonar readings
 //    return sonar_value;
 //}
 
@@ -220,6 +220,6 @@ int* SonarControl::get_sonar_readings()
  **/
 //float dist_to_sonar(float distance)
 //{
-    //TODO implement later based on sonar readings
+    //@todo implement later based on sonar readings
 //    return distance;
 //}
diff --git a/scout/libscout/src/behaviors/navigationMap.cpp b/scout/libscout/src/behaviors/navigationMap.cpp
index 0f81e3d..883a50b 100644
--- a/scout/libscout/src/behaviors/navigationMap.cpp
+++ b/scout/libscout/src/behaviors/navigationMap.cpp
@@ -219,7 +219,7 @@ State navigationMap::update_state(Turn turn_made)
     //sets the current state to the state associated with the turn made
     if(GET_EDGE_DIR(possible_edges[i]) == turn_made)
     {
-      //TODO: get actual speed
+      //@todo: get actual speed
       int speed = 10;
       curr_state = GET_EDGE_STATE(possible_edges[i]);
       Duration travel_time(GET_EDGE_DIST(possible_edges[i])/speed);
diff --git a/scout/libscout/src/helper_classes/PQWrapper.cpp b/scout/libscout/src/helper_classes/PQWrapper.cpp
index 1eb005f..1f82344 100644
--- a/scout/libscout/src/helper_classes/PQWrapper.cpp
+++ b/scout/libscout/src/helper_classes/PQWrapper.cpp
@@ -69,7 +69,7 @@ void PQWrapper::insert(Order o)
 /** @Brief: Remove and return an Order from the array if 0 <= index < arrContents. */
 Order PQWrapper::remove(unsigned int index)
 {
-    if (index >= arrContents) return minElems[-1];//TODO: can I return null?
+    if (index >= arrContents) return minElems[-1];// @todo: can I return null?
     Order toDelete = minElems[index];
     for (unsigned int i = index; i < arrContents - 1; i++) 
     {
@@ -92,7 +92,7 @@ Order PQWrapper::peek(unsigned int index) const
 {
     if (index >= arrContents)
     {
-        return minElems[-1];//TODO: can I return null?
+        return minElems[-1];// @todo: can I return null?
     } 
     else 
     {
diff --git a/scout/libscout/src/test_behaviors/Scheduler.cpp b/scout/libscout/src/test_behaviors/Scheduler.cpp
index d18e161..2901b89 100644
--- a/scout/libscout/src/test_behaviors/Scheduler.cpp
+++ b/scout/libscout/src/test_behaviors/Scheduler.cpp
@@ -100,7 +100,7 @@ Order Scheduler::get_next_item()
 
     Time end_time = order.get_start_time() - order.get_est_time();
 
-    if(end_time.toSec() + MAX_WAIT_TIME < time) //TODO: use another function
+    if(end_time.toSec() + MAX_WAIT_TIME < time) //@todo: use another function
     {
       //best = &order;
       best_index = i;
diff --git a/scout/libscout/src/test_behaviors/WH_Robot.cpp b/scout/libscout/src/test_behaviors/WH_Robot.cpp
index 17111ec..4fdabbc 100644
--- a/scout/libscout/src/test_behaviors/WH_Robot.cpp
+++ b/scout/libscout/src/test_behaviors/WH_Robot.cpp
@@ -124,7 +124,7 @@ int WH_Robot::exec_task()
 
   follow_path(new_path);
    
-  //TODO: forklift yaaaay
+  //@todo: forklift yaaaay
 
   int did_task_complete;
 
diff --git a/scout/libscout/src/test_behaviors/maze_solve.cpp b/scout/libscout/src/test_behaviors/maze_solve.cpp
index cc5904a..c7be9bc 100644
--- a/scout/libscout/src/test_behaviors/maze_solve.cpp
+++ b/scout/libscout/src/test_behaviors/maze_solve.cpp
@@ -44,12 +44,12 @@ using namespace std;
 #define LEFT 3
 #define WALL_LIMIT 500
 
-// TODO This is bad! It's defined globally across all files. Please put it inside a good scope. -Alex
+// @todo This is bad! It's defined globally across all files. Please put it inside a good scope. -Alex
 Duration sonar_update_time(1.5);
 
 void maze_solve::run()
 {    
-    // TODO:first initialize map to all 0's
+    // @todo:first initialize map to all 0's
     ROS_INFO("Starting to solve the maze");
     // Go up to the first line.
     follow_line();
diff --git a/scout/libscout/src/test_behaviors/smart_runaround.cpp b/scout/libscout/src/test_behaviors/smart_runaround.cpp
index 9a5c1a2..b07ba85 100644
--- a/scout/libscout/src/test_behaviors/smart_runaround.cpp
+++ b/scout/libscout/src/test_behaviors/smart_runaround.cpp
@@ -76,7 +76,7 @@ float *matrix_mult(float inputs[2], float matrix[2][2])
     return output;
 }
 
-// TODO This is bad! It's defined globally across all behaviors. Please fix this. -Alex
+// @todo This is bad! It's defined globally across all behaviors. Please fix this. -Alex
 Duration sonar_update_time2(1.5);
 
 // THIS VERSION MODIFIED BY ZANE
@@ -152,7 +152,7 @@ int smart_runaround::choose_direc(int row, int col, int info)
  * and turns the scout to the intended direction
  */
 void smart_runaround::turn_from_to(int current_dir, int intended_dir) {
-    switch ((4 + intended_dir - current_dir) % 4) // TODO: Try without "4 +" at start
+    switch ((4 + intended_dir - current_dir) % 4) // @todo: Try without "4 +" at start
     {
         case 0:
 	    turn_straight(intended_dir);
@@ -274,7 +274,7 @@ bool smart_runaround::look_around(int row, int col, int dir)
     return true;
 }
 
-// TODO: test this function
+// @todo: test this function
 // return true iff the map has been completely explored
 // and only true if it "returned" to home destination after solving
 bool smart_runaround::at_destination() 
@@ -306,11 +306,11 @@ bool smart_runaround::at_destination()
     return false;
 }
 
-// TODO: test these functions to make sure robot moves well
+// @todo: test these functions to make sure robot moves well
 // move forward one block in direction "dir"
 void smart_runaround::turn_straight(int dir)
 {
-    // TODO: try to use motor encoder values to move forward enough
+    // @todo: try to use motor encoder values to move forward enough
     motors->set_sides(BASESPEED, BASESPEED, MOTOR_ABSOLUTE);
     spinOnce();
     Duration moveTime(1.0);
diff --git a/scout/messages/msg/bom.msg b/scout/messages/msg/bom.msg
index 7cf2ae8..59bb74d 100644
--- a/scout/messages/msg/bom.msg
+++ b/scout/messages/msg/bom.msg
@@ -2,7 +2,7 @@ int8 sender
 int8 send_dir
 int8 recv_dir
 
-# TODO these may need to be changed
+# @todo these may need to be changed
 int8 FRONT = 0
 int8 LEFT  = 1
 int8 BACK  = 2
diff --git a/scout/painter/src/paint-i2c.cpp b/scout/painter/src/paint-i2c.cpp
index 021b312..7b791bf 100644
--- a/scout/painter/src/paint-i2c.cpp
+++ b/scout/painter/src/paint-i2c.cpp
@@ -67,7 +67,7 @@ int fd;
  * This function opens communication to I2C.
  */
 void i2c_start(void) {
-  /* TODO error check */
+  /* @todo error check */
   fd = open("/dev/i2c-3", O_RDWR);
   ioctl(fd, I2C_SLAVE, TRACKING_ID);
 }
diff --git a/scout/power/src/power.cpp b/scout/power/src/power.cpp
index 873d15e..6645901 100644
--- a/scout/power/src/power.cpp
+++ b/scout/power/src/power.cpp
@@ -50,14 +50,14 @@
 
 /** @todo Fix types: static */
 
-/** @TODO figure out if we can get things like the current draw from the AVR. */
-/** @TODO More generally, figure out how we get info from the AVR (avrbridge
+/** @todo figure out if we can get things like the current draw from the AVR. */
+/** @todo More generally, figure out how we get info from the AVR (avrbridge
  * node?) */
 
 uint32_t voltage; /**< the current voltage */
 uint32_t percentage; /**< current percentage of power remaining */
 uint32_t draw; /**< the current draw in mW */
-/** @TODO: figure out if these have to be uint8_t's to play nice with ROS */
+/** @todo: figure out if these have to be uint8_t's to play nice with ROS */
 bool externalpower; /**< are we on external power? */
 bool warning; /**< is the battery reporting a warning state? */
 bool critical; /**< is the battery reporting a critical state? */
@@ -85,7 +85,7 @@ bool power_query(::messages::query_power::Request &req,
 }
 
 
-/** @TODO: implement a function to send a message about the power state when
+/** @todo: implement a function to send a message about the power state when
  * it's critical. can't do much with this until I have some way of reading the
  * power state from the AVR, I don't believe. */
 
diff --git a/scout/scoutsim/GUI.py b/scout/scoutsim/GUI.py
index 8fc5a46..3bd350e 100755
--- a/scout/scoutsim/GUI.py
+++ b/scout/scoutsim/GUI.py
@@ -133,7 +133,7 @@ class Scout(object):
     def terminateOldBehavior(self):
         if self.process != None:
             # now terminate the process
-            self.process.kill() #TODO: this kills the process
+            self.process.kill()      # @todo: this kills the process
                                      #      but maybe not the rosnode
                                      #      change to "rosnode kill" instead
             # make sure old behavior is terminated before we run the new one
diff --git a/scout/scoutsim/src/scout.cpp b/scout/scoutsim/src/scout.cpp
index 9251426..1ef951d 100644
--- a/scout/scoutsim/src/scout.cpp
+++ b/scout/scoutsim/src/scout.cpp
@@ -418,7 +418,7 @@ namespace scoutsim
 
     /// Sends back the position of this scout so scoutsim can save
     /// the world state
-    /// TODO remove dt param
+    /// @todo remove dt param
     geometry_msgs::Pose2D Scout::update(double dt, wxMemoryDC& path_dc,
                                         wxMemoryDC& sonar_dc,
                                         const wxImage& path_image,
diff --git a/scout/scoutsim/src/scout_constants.h b/scout/scoutsim/src/scout_constants.h
index cdb276b..2f79a5c 100644
--- a/scout/scoutsim/src/scout_constants.h
+++ b/scout/scoutsim/src/scout_constants.h
@@ -50,7 +50,7 @@
 
 #include <messages/set_motors.h>
 
-/// TODO put these in a utility file somewhere?
+/// @todo put these in a utility file somewhere?
 #define min(x,y) ((x < y) ? x : y)
 #define max(x,y) ((x > y) ? x : y)
 