Index: wireless_8h-source.html
===================================================================
--- wireless_8h-source.html	(revision 59)
+++ wireless_8h-source.html	(revision 60)
@@ -22,40 +22,44 @@
 <a name="l00011"></a>00011 <span class="comment">//something about frame numbers for TX Status packets.</span>
 <a name="l00015"></a><a class="code" href="wireless_8h.html#f083cc95511287866eeb4337fdc75eeb">00015</a> <span class="comment"></span><span class="preprocessor">#define WL_MAX_PACKET_GROUPS 16</span>
 <a name="l00016"></a>00016 <span class="preprocessor"></span>
-<a name="l00019"></a><a class="code" href="wireless_8h.html#76900bb8726583e3b9268d8b7acb1886">00019</a> <span class="preprocessor">#define WL_DEFAULT_PAN 0x3331</span>
-<a name="l00020"></a>00020 <span class="preprocessor"></span>
-<a name="l00051"></a><a class="code" href="structPacketGroupHandler.html">00051</a> <span class="keyword">typedef</span> <span class="keyword">struct</span>
-<a name="l00052"></a>00052 <span class="keyword"></span>{
-<a name="l00058"></a><a class="code" href="structPacketGroupHandler.html#f0849c643f1b1e257ccfe96110109950">00058</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> groupCode;
-<a name="l00059"></a>00059 
-<a name="l00064"></a>00064         void (*timeout_handler) (void);
-<a name="l00065"></a>00065         
-<a name="l00075"></a>00075         void (*handle_response) (<span class="keywordtype">int</span> frame, <span class="keywordtype">int</span> received);
-<a name="l00076"></a>00076         
-<a name="l00086"></a>00086         void (*handle_receive) (<span class="keywordtype">char</span> type, <span class="keywordtype">int</span> source, <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>* packet,
-<a name="l00087"></a>00087                                                         <span class="keywordtype">int</span> length);
-<a name="l00088"></a>00088         
-<a name="l00092"></a>00092         void (*unregister) (void);
-<a name="l00093"></a>00093         
-<a name="l00094"></a>00094 } <a class="code" href="structPacketGroupHandler.html">PacketGroupHandler</a>;
-<a name="l00095"></a>00095 
-<a name="l00097"></a>00097 <span class="keywordtype">void</span> <a class="code" href="group__wireless.html#g629ceefdf83847af356d90e2df27041c">wl_init</a>(<span class="keywordtype">void</span>);
-<a name="l00099"></a>00099 <span class="keywordtype">void</span> <a class="code" href="group__wireless.html#g66075ff87a1c9f2c0d7938a26c7830f2">wl_terminate</a>(<span class="keywordtype">void</span>);
-<a name="l00101"></a>00101 <span class="keywordtype">void</span> <a class="code" href="group__wireless.html#g5c1f1a0e20fc718e59edc29246afd703">wl_do</a>(<span class="keywordtype">void</span>);
-<a name="l00103"></a>00103 <span class="keywordtype">void</span> <a class="code" href="group__wireless.html#g183343ed0594ec1c2b79bb4085d57107">wl_register_packet_group</a>(<a class="code" href="structPacketGroupHandler.html">PacketGroupHandler</a>* h);
-<a name="l00105"></a>00105 <span class="keywordtype">void</span> <a class="code" href="group__wireless.html#gcdbedf6465798abc7af3bf5fea3d4dd7">wl_unregister_packet_group</a>(<a class="code" href="structPacketGroupHandler.html">PacketGroupHandler</a>* h);
-<a name="l00107"></a>00107 <span class="keywordtype">void</span> <a class="code" href="group__wireless.html#ga7175b13dbfc0b11b341fbe0ad7c637c">wl_send_robot_to_robot_global_packet</a>(<span class="keywordtype">char</span> group, <span class="keywordtype">char</span> type,
+<a name="l00047"></a><a class="code" href="structPacketGroupHandler.html">00047</a> <span class="keyword">typedef</span> <span class="keyword">struct</span>
+<a name="l00048"></a>00048 <span class="keyword"></span>{
+<a name="l00054"></a><a class="code" href="structPacketGroupHandler.html#f0849c643f1b1e257ccfe96110109950">00054</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> groupCode;
+<a name="l00055"></a>00055 
+<a name="l00060"></a>00060         void (*timeout_handler) (void);
+<a name="l00061"></a>00061         
+<a name="l00071"></a>00071         void (*handle_response) (<span class="keywordtype">int</span> frame, <span class="keywordtype">int</span> received);
+<a name="l00072"></a>00072         
+<a name="l00082"></a>00082         void (*handle_receive) (<span class="keywordtype">char</span> type, <span class="keywordtype">int</span> source, <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>* packet,
+<a name="l00083"></a>00083                                                         <span class="keywordtype">int</span> length);
+<a name="l00084"></a>00084         
+<a name="l00088"></a>00088         void (*unregister) (void);
+<a name="l00089"></a>00089         
+<a name="l00090"></a>00090 } <a class="code" href="structPacketGroupHandler.html">PacketGroupHandler</a>;
+<a name="l00091"></a>00091 
+<a name="l00093"></a>00093 <span class="keywordtype">void</span> <a class="code" href="group__wireless.html#g629ceefdf83847af356d90e2df27041c">wl_init</a>(<span class="keywordtype">void</span>);
+<a name="l00095"></a>00095 <span class="keywordtype">void</span> <a class="code" href="group__wireless.html#g66075ff87a1c9f2c0d7938a26c7830f2">wl_terminate</a>(<span class="keywordtype">void</span>);
+<a name="l00097"></a>00097 <span class="keywordtype">void</span> <a class="code" href="group__wireless.html#g5c1f1a0e20fc718e59edc29246afd703">wl_do</a>(<span class="keywordtype">void</span>);
+<a name="l00099"></a>00099 <span class="keywordtype">void</span> <a class="code" href="group__wireless.html#g183343ed0594ec1c2b79bb4085d57107">wl_register_packet_group</a>(<a class="code" href="structPacketGroupHandler.html">PacketGroupHandler</a>* h);
+<a name="l00101"></a>00101 <span class="keywordtype">void</span> <a class="code" href="group__wireless.html#gcdbedf6465798abc7af3bf5fea3d4dd7">wl_unregister_packet_group</a>(<a class="code" href="structPacketGroupHandler.html">PacketGroupHandler</a>* h);
+<a name="l00102"></a>00102 
+<a name="l00104"></a>00104 <span class="keywordtype">void</span> <a class="code" href="group__wireless.html#ga7175b13dbfc0b11b341fbe0ad7c637c">wl_send_robot_to_robot_global_packet</a>(<span class="keywordtype">char</span> group, <span class="keywordtype">char</span> type,
+<a name="l00105"></a>00105                 <span class="keywordtype">char</span>* data, <span class="keywordtype">int</span> len, <span class="keywordtype">int</span> dest, <span class="keywordtype">char</span> frame);
+<a name="l00107"></a>00107 <span class="keywordtype">void</span> <a class="code" href="group__wireless.html#gafaca74445d215cef2b2e0ae1a1c72ba">wl_send_robot_to_robot_packet</a>(<span class="keywordtype">char</span> group, <span class="keywordtype">char</span> type,
 <a name="l00108"></a>00108                 <span class="keywordtype">char</span>* data, <span class="keywordtype">int</span> len, <span class="keywordtype">int</span> dest, <span class="keywordtype">char</span> frame);
-<a name="l00110"></a>00110 <span class="keywordtype">void</span> <a class="code" href="group__wireless.html#gafaca74445d215cef2b2e0ae1a1c72ba">wl_send_robot_to_robot_packet</a>(<span class="keywordtype">char</span> group, <span class="keywordtype">char</span> type,
-<a name="l00111"></a>00111                 <span class="keywordtype">char</span>* data, <span class="keywordtype">int</span> len, <span class="keywordtype">int</span> dest, <span class="keywordtype">char</span> frame);
-<a name="l00113"></a>00113 <span class="keywordtype">void</span> <a class="code" href="group__wireless.html#gdd534c99c49d5207fe09f02af304c1ad">wl_send_global_packet</a>(<span class="keywordtype">char</span> group, <span class="keywordtype">char</span> type,
+<a name="l00110"></a>00110 <span class="keywordtype">void</span> <a class="code" href="group__wireless.html#gdd534c99c49d5207fe09f02af304c1ad">wl_send_global_packet</a>(<span class="keywordtype">char</span> group, <span class="keywordtype">char</span> type,
+<a name="l00111"></a>00111                 <span class="keywordtype">char</span>* data, <span class="keywordtype">int</span> len, <span class="keywordtype">char</span> frame);
+<a name="l00113"></a>00113 <span class="keywordtype">void</span> <a class="code" href="group__wireless.html#g0a1a0e4d885f0e0dde87160a16daa0aa">wl_send_pan_packet</a>(<span class="keywordtype">char</span> group, <span class="keywordtype">char</span> type,
 <a name="l00114"></a>00114                 <span class="keywordtype">char</span>* data, <span class="keywordtype">int</span> len, <span class="keywordtype">char</span> frame);
-<a name="l00116"></a>00116 <span class="keywordtype">void</span> <a class="code" href="group__wireless.html#g0a1a0e4d885f0e0dde87160a16daa0aa">wl_send_pan_packet</a>(<span class="keywordtype">char</span> group, <span class="keywordtype">char</span> type,
-<a name="l00117"></a>00117                 <span class="keywordtype">char</span>* data, <span class="keywordtype">int</span> len, <span class="keywordtype">char</span> frame);
-<a name="l00119"></a>00119 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="group__wireless.html#g90cb41c855ac3da028e8f1278bd49f4f">wl_get_xbee_id</a>(<span class="keywordtype">void</span>);
-<a name="l00120"></a>00120  <span class="comment">// end defgroup</span>
-<a name="l00122"></a>00122 
-</pre></div><hr size="1"><address style="align: right;"><small>Generated on Fri Sep 21 12:57:06 2007 for libwireless by&nbsp;
+<a name="l00115"></a>00115 
+<a name="l00117"></a>00117 <span class="keywordtype">void</span> <a class="code" href="group__wireless.html#g211ccf907dce4493813573e20264e542">wl_set_pan</a>(<span class="keywordtype">int</span> pan);
+<a name="l00119"></a>00119 <span class="keywordtype">int</span> <a class="code" href="group__wireless.html#g4e6b5c97d40a8e7557a1b4b90a7d34f7">wl_get_pan</a>(<span class="keywordtype">void</span>);
+<a name="l00121"></a>00121 <span class="keywordtype">void</span> <a class="code" href="group__wireless.html#g9aac809e57c9eb93a2905ed544c93aba">wl_set_channel</a>(<span class="keywordtype">int</span> channel);
+<a name="l00123"></a>00123 <span class="keywordtype">int</span> <a class="code" href="group__wireless.html#g2d65d3e35b193da4213755c4bf61ab6b">wl_get_channel</a>(<span class="keywordtype">void</span>);
+<a name="l00125"></a>00125 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="group__wireless.html#g90cb41c855ac3da028e8f1278bd49f4f">wl_get_xbee_id</a>(<span class="keywordtype">void</span>);
+<a name="l00126"></a>00126  <span class="comment">// end defgroup</span>
+<a name="l00128"></a>00128 
+</pre></div><hr size="1"><address style="align: right;"><small>Generated on Mon Sep 24 14:12:30 2007 for libwireless by&nbsp;
 <a href="http://www.doxygen.org/index.html">
 <img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.4.6 </small></address>
 </body>