commit 64cefaf3ea03171842f213d349763da9ca5a0a55
Author: Julian Binder <jabinder@andrew.cmu.edu>
Date:   Fri Nov 30 17:29:50 2012 -0500

    fixed output logic on pushbutton controller

diff --git a/scoutfly/scoutfly_rev3.brd b/scoutfly/scoutfly_rev3.brd
index baebc62..58c9120 100755
--- a/scoutfly/scoutfly_rev3.brd
+++ b/scoutfly/scoutfly_rev3.brd
@@ -3103,7 +3103,7 @@ Please make sure your boards conform to these design rules.</description>
 <via x="53.975" y="62.23" extent="1-16" drill="0.381"/>
 <via x="52.832" y="62.23" extent="1-16" drill="0.381"/>
 <via x="51.689" y="62.23" extent="1-16" drill="0.381"/>
-<via x="50.546" y="62.23" extent="1-16" drill="0.381"/>
+<via x="50.165" y="62.738" extent="1-16" drill="0.381"/>
 <via x="49.403" y="62.23" extent="1-16" drill="0.381"/>
 <via x="102.997" y="88.011" extent="1-16" drill="0.381"/>
 <via x="104.267" y="88.011" extent="1-16" drill="0.381"/>
@@ -8721,13 +8721,11 @@ Please make sure your boards conform to these design rules.</description>
 <via x="29.591" y="56.261" extent="1-16" drill="0.6"/>
 </signal>
 <signal name="SHDN">
-<contactref element="U$9" pad="5"/>
 <contactref element="U$3" pad="5"/>
 <contactref element="U$10" pad="1"/>
 <wire x1="7.112" y1="62.357" x2="19.431" y2="62.357" width="0.4064" layer="16"/>
 <wire x1="29.21" y1="57.785" x2="31.496" y2="57.785" width="0.4064" layer="1"/>
 <wire x1="31.496" y1="57.785" x2="31.75" y2="58.039" width="0.4064" layer="1"/>
-<wire x1="31.75" y1="58.039" x2="31.75" y2="58.968" width="0.4064" layer="1"/>
 <wire x1="40.767" y1="85.311" x2="43.209" y2="85.311" width="0.4064" layer="1"/>
 <wire x1="40.767" y1="83.566" x2="40.767" y2="85.311" width="0.4064" layer="1"/>
 <wire x1="40.386" y1="83.185" x2="40.767" y2="83.566" width="0.4064" layer="1"/>
@@ -8756,6 +8754,8 @@ Please make sure your boards conform to these design rules.</description>
 <via x="27.559" y="76.708" extent="1-16" drill="0.6"/>
 <via x="15.367" y="56.134" extent="1-16" drill="0.6"/>
 <via x="20.828" y="63.754" extent="1-16" drill="0.6"/>
+<contactref element="U$9" pad="4"/>
+<wire x1="31.75" y1="58.039" x2="32.7" y2="58.968" width="0" layer="19" extent="1-1"/>
 </signal>
 <signal name="ARM_SHDN">
 <contactref element="U10" pad="8"/>
@@ -8806,16 +8806,18 @@ Please make sure your boards conform to these design rules.</description>
 <wire x1="32.7" y1="56.348" x2="32.7" y2="55.052" width="0.2032" layer="1"/>
 <wire x1="32.7" y1="55.052" x2="28.194" y2="50.546" width="0.2032" layer="1"/>
 <wire x1="28.194" y1="50.546" x2="28.194" y2="45.72" width="0.2032" layer="1"/>
-<wire x1="28.194" y1="45.72" x2="25.4" y2="42.926" width="0.2032" layer="1"/>
-<wire x1="25.4" y1="42.926" x2="2.54" y2="42.926" width="0.2032" layer="1"/>
-<wire x1="2.54" y1="42.926" x2="1.27" y2="41.656" width="0.2032" layer="1"/>
-<wire x1="1.27" y1="41.656" x2="1.27" y2="22.86" width="0.2032" layer="1"/>
-<wire x1="1.27" y1="22.86" x2="1.397" y2="22.733" width="0.2032" layer="1"/>
-<via x="1.397" y="22.733" extent="1-16" drill="0.381"/>
-<wire x1="1.397" y1="22.733" x2="1.905" y2="22.733" width="0.2032" layer="16"/>
-<wire x1="1.905" y1="22.733" x2="2.921" y2="23.749" width="0.2032" layer="16"/>
-<wire x1="2.921" y1="23.749" x2="13.208" y2="23.749" width="0.2032" layer="16"/>
+<wire x1="28.194" y1="45.72" x2="25.527" y2="43.561" width="0.2032" layer="1"/>
+<wire x1="25.527" y1="43.561" x2="2.54" y2="43.561" width="0.2032" layer="1"/>
+<wire x1="1.778" y1="23.749" x2="13.208" y2="23.749" width="0.2032" layer="16"/>
 <wire x1="13.208" y1="23.749" x2="14.732" y2="22.225" width="0.2032" layer="16"/>
+<wire x1="2.54" y1="43.561" x2="1.651" y2="44.45" width="0.2032" layer="1"/>
+<wire x1="1.651" y1="44.45" x2="1.651" y2="44.831" width="0.2032" layer="1"/>
+<wire x1="1.651" y1="44.831" x2="1.143" y2="45.339" width="0.2032" layer="1"/>
+<via x="1.143" y="45.339" extent="1-16" drill="0.381"/>
+<wire x1="1.143" y1="45.339" x2="1.143" y2="43.942" width="0.2032" layer="16"/>
+<wire x1="1.143" y1="43.942" x2="1.016" y2="43.815" width="0.2032" layer="16"/>
+<wire x1="1.016" y1="43.815" x2="1.016" y2="24.511" width="0.2032" layer="16"/>
+<wire x1="1.778" y1="23.749" x2="1.016" y2="24.511" width="0.2032" layer="16"/>
 </signal>
 </signals>
 </board>
diff --git a/scoutfly/scoutfly_rev3.sch b/scoutfly/scoutfly_rev3.sch
index 40fc50c..87423b7 100755
--- a/scoutfly/scoutfly_rev3.sch
+++ b/scoutfly/scoutfly_rev3.sch
@@ -24100,11 +24100,6 @@ W = angled&lt;p&gt;
 </net>
 <net name="SHDN" class="0">
 <segment>
-<wire x1="-419.1" y1="22.86" x2="-403.86" y2="22.86" width="0.1524" layer="91"/>
-<label x="-411.48" y="22.86" size="1.778" layer="95"/>
-<pinref part="U$9" gate="G$1" pin="!OUT"/>
-</segment>
-<segment>
 <wire x1="-393.7" y1="83.82" x2="-396.24" y2="83.82" width="0.1524" layer="91"/>
 <wire x1="-396.24" y1="83.82" x2="-396.24" y2="76.2" width="0.1524" layer="91"/>
 <label x="-396.24" y="76.2" size="1.778" layer="95" rot="R90"/>
@@ -24115,6 +24110,11 @@ W = angled&lt;p&gt;
 <label x="-360.68" y="124.46" size="1.778" layer="95"/>
 <pinref part="U$10" gate="G$1" pin="SHDN"/>
 </segment>
+<segment>
+<pinref part="U$9" gate="G$1" pin="OUT"/>
+<wire x1="-419.1" y1="30.48" x2="-403.86" y2="30.48" width="0.1524" layer="91"/>
+<label x="-411.48" y="30.48" size="1.778" layer="95"/>
+</segment>
 </net>
 <net name="ARM_SHDN" class="0">
 <segment>