commit 4dcab71d65ee319c0ff8b0e0c918c36bd67977a0
Author: Alex <azirbel@andrew.cmu.edu>
Date:   Thu May 2 22:37:50 2013 -0400

    Added danger_marking_blind for even dumber runaround.
    
    If sonar doesn't work for the demo, we can use this. It drives in a circle.

diff --git a/scout/libscout/src/test_behaviors/danger_marking_blind.cpp b/scout/libscout/src/test_behaviors/danger_marking_blind.cpp
new file mode 100644
index 0000000..556af56
--- /dev/null
+++ b/scout/libscout/src/test_behaviors/danger_marking_blind.cpp
@@ -0,0 +1,57 @@
+/**
+ * Copyright (c) 2011 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ */
+
+#include "danger_marking_blind.h"
+
+#define THRESH 200
+#define min(x,y) ((x < y) ? x : y)
+
+using namespace std;
+
+void danger_marking_blind::run()
+{    
+    ROS_INFO("Starting Danger Marking (Blind Mode).");
+
+    motors->set_sides(30, 50);
+
+    while (true)
+    {
+        get_position();
+        ROS_INFO("Position: (%f, %f, %f).",
+            scout_pos->x, scout_pos->y, scout_pos->theta);
+
+        if (metal_detector->query()) //FOUND SOME METAL!
+        {
+            paintboard->set(DISPENSE_PAINT);
+        }
+        else
+        {
+            if(paintboard->query()) //No metal, but dispensing paint;
+            {
+                paintboard->set(STOP_PAINT);
+            }
+        }
+    }
+}
diff --git a/scout/libscout/src/test_behaviors/danger_marking_blind.h b/scout/libscout/src/test_behaviors/danger_marking_blind.h
new file mode 100644
index 0000000..344df6f
--- /dev/null
+++ b/scout/libscout/src/test_behaviors/danger_marking_blind.h
@@ -0,0 +1,43 @@
+/**
+ * Copyright (c) 2011 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ */
+
+#ifndef _DANGER_MARKING_BLIND_H_
+#define _DANGER_MARKING_BLIND_H_
+
+#include <stdio.h>
+#include "../behaviors/Odometry.h"
+
+/**
+ * A very simple maze solver that always turns right.
+ */
+class danger_marking_blind : public Odometry
+{
+    public:
+        danger_marking_blind(std::string scoutname, Sensors* sensors):
+            Odometry(scoutname, "danger_marking_blind", sensors) {};
+        void run();
+};
+#endif
+