commit b3fc8ce73f68975fc610b69e47707c6bf6df1af5
Author: Jeff Cooper <jdcooper@andrew.cmu.edu>
Date:   Fri Nov 11 02:26:21 2011 -0500

    de-crapping the repository. Kids, don't git add * if you don't know what you're doing.

diff --git a/scout/power/src/power/__init__.py b/scout/power/src/power/__init__.py
deleted file mode 100644
index e69de29..0000000
diff --git a/scout/power/src/power/msg/__init__.py b/scout/power/src/power/msg/__init__.py
deleted file mode 100644
index d9a51a2..0000000
--- a/scout/power/src/power/msg/__init__.py
+++ /dev/null
@@ -1 +0,0 @@
-from _power_state_changed import *
diff --git a/scout/power/src/power/msg/_power_state_changed.py b/scout/power/src/power/msg/_power_state_changed.py
deleted file mode 100644
index ea55b71..0000000
--- a/scout/power/src/power/msg/_power_state_changed.py
+++ /dev/null
@@ -1,197 +0,0 @@
-"""autogenerated by genmsg_py from power_state_changed.msg. Do not edit."""
-import roslib.message
-import struct
-
-import std_msgs.msg
-
-class power_state_changed(roslib.message.Message):
-  _md5sum = "fc98f58bb6056947bbbbbad6cc36490a"
-  _type = "power/power_state_changed"
-  _has_header = True #flag to mark the presence of a Header object
-  _full_text = """Header header
-#32-bit integer with current voltage info
-uint32 voltage
-#power percentage [0-100]
-uint32 percentage
-#current draw in mW
-uint32 draw
-#are we on external power?
-bool externalpower
-#is the battery at a warning state?
-bool warning
-#is the battery at a critical state?
-bool critical
-
-
-================================================================================
-MSG: std_msgs/Header
-# Standard metadata for higher-level stamped data types.
-# This is generally used to communicate timestamped data 
-# in a particular coordinate frame.
-# 
-# sequence ID: consecutively increasing ID 
-uint32 seq
-#Two-integer timestamp that is expressed as:
-# * stamp.secs: seconds (stamp_secs) since epoch
-# * stamp.nsecs: nanoseconds since stamp_secs
-# time-handling sugar is provided by the client library
-time stamp
-#Frame this data is associated with
-# 0: no frame
-# 1: global frame
-string frame_id
-
-"""
-  __slots__ = ['header','voltage','percentage','draw','externalpower','warning','critical']
-  _slot_types = ['Header','uint32','uint32','uint32','bool','bool','bool']
-
-  def __init__(self, *args, **kwds):
-    """
-    Constructor. Any message fields that are implicitly/explicitly
-    set to None will be assigned a default value. The recommend
-    use is keyword arguments as this is more robust to future message
-    changes.  You cannot mix in-order arguments and keyword arguments.
-    
-    The available fields are:
-       header,voltage,percentage,draw,externalpower,warning,critical
-    
-    @param args: complete set of field values, in .msg order
-    @param kwds: use keyword arguments corresponding to message field names
-    to set specific fields. 
-    """
-    if args or kwds:
-      super(power_state_changed, self).__init__(*args, **kwds)
-      #message fields cannot be None, assign default values for those that are
-      if self.header is None:
-        self.header = std_msgs.msg._Header.Header()
-      if self.voltage is None:
-        self.voltage = 0
-      if self.percentage is None:
-        self.percentage = 0
-      if self.draw is None:
-        self.draw = 0
-      if self.externalpower is None:
-        self.externalpower = False
-      if self.warning is None:
-        self.warning = False
-      if self.critical is None:
-        self.critical = False
-    else:
-      self.header = std_msgs.msg._Header.Header()
-      self.voltage = 0
-      self.percentage = 0
-      self.draw = 0
-      self.externalpower = False
-      self.warning = False
-      self.critical = False
-
-  def _get_types(self):
-    """
-    internal API method
-    """
-    return self._slot_types
-
-  def serialize(self, buff):
-    """
-    serialize message into buffer
-    @param buff: buffer
-    @type  buff: StringIO
-    """
-    try:
-      _x = self
-      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
-      _x = self.header.frame_id
-      length = len(_x)
-      buff.write(struct.pack('<I%ss'%length, length, _x))
-      _x = self
-      buff.write(_struct_3I3B.pack(_x.voltage, _x.percentage, _x.draw, _x.externalpower, _x.warning, _x.critical))
-    except struct.error, se: self._check_types(se)
-    except TypeError, te: self._check_types(te)
-
-  def deserialize(self, str):
-    """
-    unpack serialized message in str into this message instance
-    @param str: byte array of serialized message
-    @type  str: str
-    """
-    try:
-      if self.header is None:
-        self.header = std_msgs.msg._Header.Header()
-      end = 0
-      _x = self
-      start = end
-      end += 12
-      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
-      start = end
-      end += 4
-      (length,) = _struct_I.unpack(str[start:end])
-      start = end
-      end += length
-      self.header.frame_id = str[start:end]
-      _x = self
-      start = end
-      end += 15
-      (_x.voltage, _x.percentage, _x.draw, _x.externalpower, _x.warning, _x.critical,) = _struct_3I3B.unpack(str[start:end])
-      self.externalpower = bool(self.externalpower)
-      self.warning = bool(self.warning)
-      self.critical = bool(self.critical)
-      return self
-    except struct.error, e:
-      raise roslib.message.DeserializationError(e) #most likely buffer underfill
-
-
-  def serialize_numpy(self, buff, numpy):
-    """
-    serialize message with numpy array types into buffer
-    @param buff: buffer
-    @type  buff: StringIO
-    @param numpy: numpy python module
-    @type  numpy module
-    """
-    try:
-      _x = self
-      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
-      _x = self.header.frame_id
-      length = len(_x)
-      buff.write(struct.pack('<I%ss'%length, length, _x))
-      _x = self
-      buff.write(_struct_3I3B.pack(_x.voltage, _x.percentage, _x.draw, _x.externalpower, _x.warning, _x.critical))
-    except struct.error, se: self._check_types(se)
-    except TypeError, te: self._check_types(te)
-
-  def deserialize_numpy(self, str, numpy):
-    """
-    unpack serialized message in str into this message instance using numpy for array types
-    @param str: byte array of serialized message
-    @type  str: str
-    @param numpy: numpy python module
-    @type  numpy: module
-    """
-    try:
-      if self.header is None:
-        self.header = std_msgs.msg._Header.Header()
-      end = 0
-      _x = self
-      start = end
-      end += 12
-      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
-      start = end
-      end += 4
-      (length,) = _struct_I.unpack(str[start:end])
-      start = end
-      end += length
-      self.header.frame_id = str[start:end]
-      _x = self
-      start = end
-      end += 15
-      (_x.voltage, _x.percentage, _x.draw, _x.externalpower, _x.warning, _x.critical,) = _struct_3I3B.unpack(str[start:end])
-      self.externalpower = bool(self.externalpower)
-      self.warning = bool(self.warning)
-      self.critical = bool(self.critical)
-      return self
-    except struct.error, e:
-      raise roslib.message.DeserializationError(e) #most likely buffer underfill
-
-_struct_I = roslib.message.struct_I
-_struct_3I = struct.Struct("<3I")
-_struct_3I3B = struct.Struct("<3I3B")
diff --git a/scout/power/src/power/srv/__init__.py b/scout/power/src/power/srv/__init__.py
deleted file mode 100644
index 5605cbe..0000000
--- a/scout/power/src/power/srv/__init__.py
+++ /dev/null
@@ -1 +0,0 @@
-from _query_power import *
diff --git a/scout/power/src/power/srv/_query_power.py b/scout/power/src/power/srv/_query_power.py
deleted file mode 100644
index e373a33..0000000
--- a/scout/power/src/power/srv/_query_power.py
+++ /dev/null
@@ -1,233 +0,0 @@
-"""autogenerated by genmsg_py from query_powerRequest.msg. Do not edit."""
-import roslib.message
-import struct
-
-
-class query_powerRequest(roslib.message.Message):
-  _md5sum = "d41d8cd98f00b204e9800998ecf8427e"
-  _type = "power/query_powerRequest"
-  _has_header = False #flag to mark the presence of a Header object
-  _full_text = """
-"""
-  __slots__ = []
-  _slot_types = []
-
-  def __init__(self, *args, **kwds):
-    """
-    Constructor. Any message fields that are implicitly/explicitly
-    set to None will be assigned a default value. The recommend
-    use is keyword arguments as this is more robust to future message
-    changes.  You cannot mix in-order arguments and keyword arguments.
-    
-    The available fields are:
-       
-    
-    @param args: complete set of field values, in .msg order
-    @param kwds: use keyword arguments corresponding to message field names
-    to set specific fields. 
-    """
-    if args or kwds:
-      super(query_powerRequest, self).__init__(*args, **kwds)
-
-  def _get_types(self):
-    """
-    internal API method
-    """
-    return self._slot_types
-
-  def serialize(self, buff):
-    """
-    serialize message into buffer
-    @param buff: buffer
-    @type  buff: StringIO
-    """
-    try:
-      pass
-    except struct.error, se: self._check_types(se)
-    except TypeError, te: self._check_types(te)
-
-  def deserialize(self, str):
-    """
-    unpack serialized message in str into this message instance
-    @param str: byte array of serialized message
-    @type  str: str
-    """
-    try:
-      end = 0
-      return self
-    except struct.error, e:
-      raise roslib.message.DeserializationError(e) #most likely buffer underfill
-
-
-  def serialize_numpy(self, buff, numpy):
-    """
-    serialize message with numpy array types into buffer
-    @param buff: buffer
-    @type  buff: StringIO
-    @param numpy: numpy python module
-    @type  numpy module
-    """
-    try:
-      pass
-    except struct.error, se: self._check_types(se)
-    except TypeError, te: self._check_types(te)
-
-  def deserialize_numpy(self, str, numpy):
-    """
-    unpack serialized message in str into this message instance using numpy for array types
-    @param str: byte array of serialized message
-    @type  str: str
-    @param numpy: numpy python module
-    @type  numpy: module
-    """
-    try:
-      end = 0
-      return self
-    except struct.error, e:
-      raise roslib.message.DeserializationError(e) #most likely buffer underfill
-
-_struct_I = roslib.message.struct_I
-"""autogenerated by genmsg_py from query_powerResponse.msg. Do not edit."""
-import roslib.message
-import struct
-
-
-class query_powerResponse(roslib.message.Message):
-  _md5sum = "7f7505c0b2499fcf6c85ecc5dee6164e"
-  _type = "power/query_powerResponse"
-  _has_header = False #flag to mark the presence of a Header object
-  _full_text = """
-uint32 voltage
-
-uint32 percentage
-
-uint32 draw
-
-bool externalpower
-
-bool warning
-
-bool critical
-
-
-"""
-  __slots__ = ['voltage','percentage','draw','externalpower','warning','critical']
-  _slot_types = ['uint32','uint32','uint32','bool','bool','bool']
-
-  def __init__(self, *args, **kwds):
-    """
-    Constructor. Any message fields that are implicitly/explicitly
-    set to None will be assigned a default value. The recommend
-    use is keyword arguments as this is more robust to future message
-    changes.  You cannot mix in-order arguments and keyword arguments.
-    
-    The available fields are:
-       voltage,percentage,draw,externalpower,warning,critical
-    
-    @param args: complete set of field values, in .msg order
-    @param kwds: use keyword arguments corresponding to message field names
-    to set specific fields. 
-    """
-    if args or kwds:
-      super(query_powerResponse, self).__init__(*args, **kwds)
-      #message fields cannot be None, assign default values for those that are
-      if self.voltage is None:
-        self.voltage = 0
-      if self.percentage is None:
-        self.percentage = 0
-      if self.draw is None:
-        self.draw = 0
-      if self.externalpower is None:
-        self.externalpower = False
-      if self.warning is None:
-        self.warning = False
-      if self.critical is None:
-        self.critical = False
-    else:
-      self.voltage = 0
-      self.percentage = 0
-      self.draw = 0
-      self.externalpower = False
-      self.warning = False
-      self.critical = False
-
-  def _get_types(self):
-    """
-    internal API method
-    """
-    return self._slot_types
-
-  def serialize(self, buff):
-    """
-    serialize message into buffer
-    @param buff: buffer
-    @type  buff: StringIO
-    """
-    try:
-      _x = self
-      buff.write(_struct_3I3B.pack(_x.voltage, _x.percentage, _x.draw, _x.externalpower, _x.warning, _x.critical))
-    except struct.error, se: self._check_types(se)
-    except TypeError, te: self._check_types(te)
-
-  def deserialize(self, str):
-    """
-    unpack serialized message in str into this message instance
-    @param str: byte array of serialized message
-    @type  str: str
-    """
-    try:
-      end = 0
-      _x = self
-      start = end
-      end += 15
-      (_x.voltage, _x.percentage, _x.draw, _x.externalpower, _x.warning, _x.critical,) = _struct_3I3B.unpack(str[start:end])
-      self.externalpower = bool(self.externalpower)
-      self.warning = bool(self.warning)
-      self.critical = bool(self.critical)
-      return self
-    except struct.error, e:
-      raise roslib.message.DeserializationError(e) #most likely buffer underfill
-
-
-  def serialize_numpy(self, buff, numpy):
-    """
-    serialize message with numpy array types into buffer
-    @param buff: buffer
-    @type  buff: StringIO
-    @param numpy: numpy python module
-    @type  numpy module
-    """
-    try:
-      _x = self
-      buff.write(_struct_3I3B.pack(_x.voltage, _x.percentage, _x.draw, _x.externalpower, _x.warning, _x.critical))
-    except struct.error, se: self._check_types(se)
-    except TypeError, te: self._check_types(te)
-
-  def deserialize_numpy(self, str, numpy):
-    """
-    unpack serialized message in str into this message instance using numpy for array types
-    @param str: byte array of serialized message
-    @type  str: str
-    @param numpy: numpy python module
-    @type  numpy: module
-    """
-    try:
-      end = 0
-      _x = self
-      start = end
-      end += 15
-      (_x.voltage, _x.percentage, _x.draw, _x.externalpower, _x.warning, _x.critical,) = _struct_3I3B.unpack(str[start:end])
-      self.externalpower = bool(self.externalpower)
-      self.warning = bool(self.warning)
-      self.critical = bool(self.critical)
-      return self
-    except struct.error, e:
-      raise roslib.message.DeserializationError(e) #most likely buffer underfill
-
-_struct_I = roslib.message.struct_I
-_struct_3I3B = struct.Struct("<3I3B")
-class query_power(roslib.message.ServiceDefinition):
-  _type          = 'power/query_power'
-  _md5sum = '7f7505c0b2499fcf6c85ecc5dee6164e'
-  _request_class  = query_powerRequest
-  _response_class = query_powerResponse